package ch.std.rest.upload.service;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.nio.file.Files;
import java.nio.file.Path;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

@Service
public class FileService {
	
	Logger logger = LoggerFactory.getLogger(FileService.class);

	@Value("${upload.service.path}")
	private String rootPath;
	
	public FileService() {
	}
	
	public Path save(String fileName, InputStream is) throws IOException {
		byte[] buffer = new byte[1 << 20];
		int bytesRead = -1;
		int bytesWritten = 0;
		Path out = Path.of(rootPath, fileName);
		try (OutputStream os = Files.newOutputStream(out)) {
			while((bytesRead = is.read(buffer)) > 0) {
				os.write(buffer, 0, bytesRead);
				bytesWritten += bytesRead;
			}
		}
		logger.info("file " + fileName + " written to path " + out + ", bytes written " + bytesWritten);
		return out;
	}
	
}
